import{S as Mr,i as Or,s as Wr,e as a,k as c,w as _,t as s,M as zr,c as l,d as t,m as d,a as n,x as w,h as r,b as p,N as Ze,G as o,g as h,y,L as Br,q as b,o as E,B as A,v as Hr}from"../../chunks/vendor-hf-doc-builder.js";import{I as ne}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as ja}from"../../chunks/CodeBlock-hf-doc-builder.js";function Fr(ts){let I,no,P,O,wt,se,Ia,yt,Pa,so,T,re,Ta,La,bt,Ra,Sa,ro,Ve,qa,io,f,ie,Ca,he,Na,Da,Ma,m,Oa,pe,Wa,za,ce,Ba,Ha,de,Fa,Ya,fe,Ua,Ja,Et,Ka,Qa,Xe,Za,At,Va,Xa,ue,el,kt,tl,ol,al,me,ll,Gt,nl,sl,ho,g,rl,ge,il,hl,ve,pl,cl,_e,dl,fl,po,L,W,xt,we,ul,$t,ml,co,z,gl,jt,vl,_l,fo,B,wl,It,yl,bl,uo,H,El,Pt,Al,kl,mo,ye,os,go,R,F,Tt,be,Gl,Lt,xl,vo,k,$l,Ee,jl,Il,Rt,Pl,Tl,_o,Y,Ll,St,Rl,Sl,wo,u,ql,Ae,Cl,Nl,ke,Dl,Ml,Ge,Ol,Wl,xe,zl,Bl,yo,U,Hl,qt,Fl,Yl,bo,et,Ul,Eo,G,Ct,$e,Jl,Kl,Nt,je,Ql,Zl,Dt,Ie,Vl,Ao,S,J,Mt,Pe,Xl,Ot,en,ko,tt,tn,Go,K,Wt,Te,on,an,zt,Le,ln,xo,x,nn,Bt,sn,rn,Ht,hn,pn,$o,ot,cn,jo,q,Q,Ft,Re,dn,Yt,fn,Io,at,un,Po,lt,mn,To,Se,as,Lo,Z,gn,qe,vn,_n,Ro,Ce,ls,So,nt,wn,qo,Ne,ns,Co,C,V,Ut,De,yn,Jt,bn,No,st,En,Do,Me,ss,Mo,$,An,Kt,kn,Gn,Qt,xn,$n,Oo,Oe,rs,Wo,rt,jn,zo,We,Bo,it,In,Ho,X,Pn,Zt,Tn,Ln,Fo,ze,Yo,ht,Rn,Uo,Be,Jo,pt,Sn,Ko,ee,qn,Vt,Cn,Nn,Qo,He,Zo,ct,Dn,Vo,Fe,Mn,Xt,On,Xo,dt,Wn,ea,Ye,is,ta,ft,zn,oa,N,te,eo,Ue,Bn,to,Hn,aa,oe,Fn,Je,Yn,Un,la,D,ae,oo,Ke,Jn,ao,Kn,na,Qe,Qn,ut,Zn,sa;return se=new ne({}),we=new ne({}),be=new ne({}),Pe=new ne({}),Re=new ne({}),De=new ne({}),We=new ja({props:{code:`#-- Methods that need implementing using the "extend script" option in Godot --#
func get_obs() -> Dictionary:
	assert(false, "the get_obs method is not implemented when extending from ai_controller")
	return {"obs":[]}

func get_reward() -> float:
	assert(false, "the get_reward method is not implemented when extending from ai_controller")
	return 0.0

func get_action_space() -> Dictionary:
	assert(false, "the get get_action_space method is not implemented when extending from ai_controller")
	return {
		"example_actions_continous" : {
			"size": 2,
			"action_type": "continuous"
		},
		"example_actions_discrete" : {
			"size": 2,
			"action_type": "discrete"
		},
		}

func set_action(action) -> void:
	assert(false, "the get set_action method is not implemented when extending from ai_controller")
# -----------------------------------------------------------------------------#`,highlighted:`<span class="hljs-comment">#-- Methods that need implementing using the &quot;extend script&quot; option in Godot --#</span>
func get_obs() -&gt; Dictionary:
	<span class="hljs-keyword">assert</span>(false, <span class="hljs-string">&quot;the get_obs method is not implemented when extending from ai_controller&quot;</span>)
	<span class="hljs-keyword">return</span> {<span class="hljs-string">&quot;obs&quot;</span>:[]}

func get_reward() -&gt; <span class="hljs-built_in">float</span>:
	<span class="hljs-keyword">assert</span>(false, <span class="hljs-string">&quot;the get_reward method is not implemented when extending from ai_controller&quot;</span>)
	<span class="hljs-keyword">return</span> <span class="hljs-number">0.0</span>

func get_action_space() -&gt; Dictionary:
	<span class="hljs-keyword">assert</span>(false, <span class="hljs-string">&quot;the get get_action_space method is not implemented when extending from ai_controller&quot;</span>)
	<span class="hljs-keyword">return</span> {
		<span class="hljs-string">&quot;example_actions_continous&quot;</span> : {
			<span class="hljs-string">&quot;size&quot;</span>: <span class="hljs-number">2</span>,
			<span class="hljs-string">&quot;action_type&quot;</span>: <span class="hljs-string">&quot;continuous&quot;</span>
		},
		<span class="hljs-string">&quot;example_actions_discrete&quot;</span> : {
			<span class="hljs-string">&quot;size&quot;</span>: <span class="hljs-number">2</span>,
			<span class="hljs-string">&quot;action_type&quot;</span>: <span class="hljs-string">&quot;discrete&quot;</span>
		},
		}

func set_action(action) -&gt; void:
	<span class="hljs-keyword">assert</span>(false, <span class="hljs-string">&quot;the get set_action method is not implemented when extending from ai_controller&quot;</span>)
<span class="hljs-comment"># -----------------------------------------------------------------------------#</span>`}}),ze=new ja({props:{code:`extends AIController3D

# Called when the node enters the scene tree for the first time.
func _ready():
	pass # Replace with function body.

# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	pass`,highlighted:`extends AIController3D

<span class="hljs-comment"># Called when the node enters the scene tree for the first time.</span>
func _ready():
	<span class="hljs-keyword">pass</span> <span class="hljs-comment"># Replace with function body.</span>

<span class="hljs-comment"># Called every frame. &#x27;delta&#x27; is the elapsed time since the previous frame.</span>
func _process(delta):
	<span class="hljs-keyword">pass</span>`}}),Be=new ja({props:{code:`extends AIController3D

# Stores the action sampled for the agent's policy, running in python
var move_action : float = 0.0

func get_obs() -> Dictionary:
	# get the balls position and velocity in the paddle's frame of reference
	var ball_pos = to_local(_player.ball.global_position)
	var ball_vel = to_local(_player.ball.linear_velocity)
	var obs = [ball_pos.x, ball_pos.z, ball_vel.x/10.0, ball_vel.z/10.0]

	return {"obs":obs}

func get_reward() -> float:
	return reward

func get_action_space() -> Dictionary:
	return {
		"move_action" : {
			"size": 1,
			"action_type": "continuous"
		},
		}

func set_action(action) -> void:
	move_action = clamp(action["move_action"][0], -1.0, 1.0)`,highlighted:`extends AIController3D

<span class="hljs-comment"># Stores the action sampled for the agent&#x27;s policy, running in python</span>
var move_action : <span class="hljs-built_in">float</span> = <span class="hljs-number">0.0</span>

func get_obs() -&gt; Dictionary:
	<span class="hljs-comment"># get the balls position and velocity in the paddle&#x27;s frame of reference</span>
	var ball_pos = to_local(_player.ball.global_position)
	var ball_vel = to_local(_player.ball.linear_velocity)
	var obs = [ball_pos.x, ball_pos.z, ball_vel.x/<span class="hljs-number">10.0</span>, ball_vel.z/<span class="hljs-number">10.0</span>]

	<span class="hljs-keyword">return</span> {<span class="hljs-string">&quot;obs&quot;</span>:obs}

func get_reward() -&gt; <span class="hljs-built_in">float</span>:
	<span class="hljs-keyword">return</span> reward

func get_action_space() -&gt; Dictionary:
	<span class="hljs-keyword">return</span> {
		<span class="hljs-string">&quot;move_action&quot;</span> : {
			<span class="hljs-string">&quot;size&quot;</span>: <span class="hljs-number">1</span>,
			<span class="hljs-string">&quot;action_type&quot;</span>: <span class="hljs-string">&quot;continuous&quot;</span>
		},
		}

func set_action(action) -&gt; void:
	move_action = clamp(action[<span class="hljs-string">&quot;move_action&quot;</span>][<span class="hljs-number">0</span>], -<span class="hljs-number">1.0</span>, <span class="hljs-number">1.0</span>)`}}),He=new ja({props:{code:`extends Node3D

@export var rotation_speed = 3.0
@onready var ball = get_node("../Ball")
@onready var ai_controller = $AIController3D

func _ready():
	ai_controller.init(self)

func game_over():
	ai_controller.done = true
	ai_controller.needs_reset = true

func _physics_process(delta):
	if ai_controller.needs_reset:
		ai_controller.reset()
		ball.reset()
		return

	var movement : float
	if ai_controller.heuristic == "human":
		movement = Input.get_axis("rotate_anticlockwise", "rotate_clockwise")
	else:
		movement = ai_controller.move_action
	rotate_y(movement*delta*rotation_speed)

func _on_area_3d_body_entered(body):
	ai_controller.reward += 1.0`,highlighted:`extends Node3D

<span class="hljs-meta">@export var rotation_speed = <span class="hljs-number">3.0</span></span>
<span class="hljs-meta">@onready var ball = get_node(<span class="hljs-params"><span class="hljs-string">&quot;../Ball&quot;</span></span>)</span>
<span class="hljs-meta">@onready var ai_controller = $AIController3D</span>

func _ready():
	ai_controller.init(self)

func game_over():
	ai_controller.done = true
	ai_controller.needs_reset = true

func _physics_process(delta):
	<span class="hljs-keyword">if</span> ai_controller.needs_reset:
		ai_controller.reset()
		ball.reset()
		<span class="hljs-keyword">return</span>

	var movement : <span class="hljs-built_in">float</span>
	<span class="hljs-keyword">if</span> ai_controller.heuristic == <span class="hljs-string">&quot;human&quot;</span>:
		movement = Input.get_axis(<span class="hljs-string">&quot;rotate_anticlockwise&quot;</span>, <span class="hljs-string">&quot;rotate_clockwise&quot;</span>)
	<span class="hljs-keyword">else</span>:
		movement = ai_controller.move_action
	rotate_y(movement*delta*rotation_speed)

func _on_area_3d_body_entered(body):
	ai_controller.reward += <span class="hljs-number">1.0</span>`}}),Ue=new ne({}),Ke=new ne({}),{c(){I=a("meta"),no=c(),P=a("h1"),O=a("a"),wt=a("span"),_(se.$$.fragment),Ia=c(),yt=a("span"),Pa=s("Godot RL Agents"),so=c(),T=a("p"),re=a("a"),Ta=s("Godot RL Agents"),La=s(" is an Open Source package that allows video game creators, AI researchers and hobbyists the opportunity "),bt=a("strong"),Ra=s("to learn complex behaviors for their Non Player Characters or agents"),Sa=s("."),ro=c(),Ve=a("p"),qa=s("The library provides:"),io=c(),f=a("ul"),ie=a("li"),Ca=s("An interface between games created in the\xA0"),he=a("a"),Na=s("Godot Engine"),Da=s("\xA0and Machine Learning algorithms running in Python"),Ma=c(),m=a("li"),Oa=s("Wrappers for four well known rl frameworks: "),pe=a("a"),Wa=s("StableBaselines3"),za=s(", "),ce=a("a"),Ba=s("CleanRL"),Ha=s(", "),de=a("a"),Fa=s("Sample Factory"),Ya=s(" and\xA0"),fe=a("a"),Ua=s("Ray RLLib"),Ja=c(),Et=a("li"),Ka=s("Support for memory-based agents with LSTM or attention based interfaces"),Qa=c(),Xe=a("li"),Za=s("Support for "),At=a("em"),Va=s("2D and 3D games"),Xa=c(),ue=a("li"),el=s("A suite of "),kt=a("em"),tl=s("AI sensors"),ol=s(" to augment your agent\u2019s capacity to observe the game world"),al=c(),me=a("li"),ll=s("Godot and Godot RL Agents are "),Gt=a("strong"),nl=s("completely free and open source under a very permissive MIT license"),sl=s(". No strings attached, no royalties, nothing."),ho=c(),g=a("p"),rl=s("You can find out more about Godot RL agents on their "),ge=a("a"),il=s("GitHub page"),hl=s(" or their AAAI-2022 Workshop\xA0"),ve=a("a"),pl=s("paper"),cl=s(". The library\u2019s creator, "),_e=a("a"),dl=s("Ed Beeching"),fl=s(", is a Research Scientist here at Hugging Face."),po=c(),L=a("h2"),W=a("a"),xt=a("span"),_(we.$$.fragment),ul=c(),$t=a("span"),ml=s("Create a custom RL environment with Godot RL Agents"),co=c(),z=a("p"),gl=s("In this section, you will "),jt=a("strong"),vl=s("learn how to create a custom environment in the Godot Game Engine"),_l=s(" and then implement an AI controller that learns to play with Deep Reinforcement Learning."),fo=c(),B=a("p"),wl=s("The example game we create today is simple, "),It=a("strong"),yl=s("but shows off many of the features of the Godot Engine and the Godot RL Agents library"),bl=s(".You can then dive into the examples for more complex environments and behaviors."),uo=c(),H=a("p"),El=s("The environment we will be building today is called Ring Pong, the game of pong but the pitch is a ring and the paddle moves around the ring. The "),Pt=a("strong"),Al=s("objective is to keep the ball bouncing inside the ring"),kl=s("."),mo=c(),ye=a("img"),go=c(),R=a("h3"),F=a("a"),Tt=a("span"),_(be.$$.fragment),Gl=c(),Lt=a("span"),xl=s("Installing the Godot Game Engine"),vo=c(),k=a("p"),$l=s("The "),Ee=a("a"),jl=s("Godot game engine"),Il=s(" is an open source tool for the "),Rt=a("strong"),Pl=s("creation of video games, tools and user interfaces"),Tl=s("."),_o=c(),Y=a("p"),Ll=s("Godot Engine is a feature-packed, cross-platform game engine designed to create 2D and 3D games from a unified interface. It provides a comprehensive set of common tools, so users "),St=a("strong"),Rl=s("can focus on making games without having to reinvent the wheel"),Sl=s(". Games can be exported in one click to a number of platforms, including the major desktop platforms (Linux, macOS, Windows) as well as mobile (Android, iOS) and web-based (HTML5) platforms."),wo=c(),u=a("p"),ql=s("While we will guide you through the steps to implement your agent, you may wish to learn more about the Godot Game Engine. Their "),Ae=a("a"),Cl=s("documentation"),Nl=s(" is thorough, there are many tutorials on YouTube we would also recommend "),ke=a("a"),Dl=s("GDQuest"),Ml=s(", "),Ge=a("a"),Ol=s("KidsCanCode"),Wl=s(" and "),xe=a("a"),zl=s("Bramwell"),Bl=s(" as sources of information."),yo=c(),U=a("p"),Hl=s("In order to create games in Godot, "),qt=a("strong"),Fl=s("you must first download the editor"),Yl=s(". The latest version Godot RL agents was updated to use Godot 4 beta, as we are expecting this to be released in the next few months."),bo=c(),et=a("p"),Ul=s("At the time of writing the latest beta version was beta 14 which can be downloaded at the following links:"),Eo=c(),G=a("ul"),Ct=a("li"),$e=a("a"),Jl=s("Windows"),Kl=c(),Nt=a("li"),je=a("a"),Ql=s("Mac"),Zl=c(),Dt=a("li"),Ie=a("a"),Vl=s("Linux"),Ao=c(),S=a("h3"),J=a("a"),Mt=a("span"),_(Pe.$$.fragment),Xl=c(),Ot=a("span"),en=s("Loading the starter project"),ko=c(),tt=a("p"),tn=s("We provide two versions of the codebase:"),Go=c(),K=a("ul"),Wt=a("li"),Te=a("a"),on=s("A starter project, to download and follow along for this tutorial"),an=c(),zt=a("li"),Le=a("a"),ln=s("A final version of the project, for comparison and debugging."),xo=c(),x=a("p"),nn=s("To load the project, in the Godot Project Manager click "),Bt=a("strong"),sn=s("Import"),rn=s(", navigate to where the files are located and load the "),Ht=a("strong"),hn=s("project.godot"),pn=s(" file."),$o=c(),ot=a("p"),cn=s("If you press F5 or play in the editor, you should be able to play the game in human mode. There are several instances of the game running, this is because we want to speed up training our AI agent with many parallel environments."),jo=c(),q=a("h3"),Q=a("a"),Ft=a("span"),_(Re.$$.fragment),dn=c(),Yt=a("span"),fn=s("Installing the Godot RL Agents plugin"),Io=c(),at=a("p"),un=s("The Godot RL Agents plugin can be installed from the Github repo or with the Godot Asset Lib in the editor."),Po=c(),lt=a("p"),mn=s("First click on the AssetLib and search for \u201Crl\u201D"),To=c(),Se=a("img"),Lo=c(),Z=a("p"),gn=s("Then click on Godot RL Agents, click Download and unselect the LICIENSE and "),qe=a("a"),vn=s("README.md"),_n=s(" files. Then click install."),Ro=c(),Ce=a("img"),So=c(),nt=a("p"),wn=s("The Godot RL Agents plugin is now downloaded to your machine your machine. Now click on Project \u2192 Project settings and enable the addon:"),qo=c(),Ne=a("img"),Co=c(),C=a("h3"),V=a("a"),Ut=a("span"),_(De.$$.fragment),yn=c(),Jt=a("span"),bn=s("Adding the AI controller"),No=c(),st=a("p"),En=s("We now want to add an AI controller to our game. Open the player.tscn scene, on the left you should see a hierarchy of nodes that looks like this:"),Do=c(),Me=a("img"),Mo=c(),$=a("p"),An=s("Right click the "),Kt=a("strong"),kn=s("Player"),Gn=s(" node and click "),Qt=a("strong"),xn=s("Add Child Node."),$n=s(" There are many nodes listed here, search for AIController3D and create it."),Oo=c(),Oe=a("img"),Wo=c(),rt=a("p"),jn=s("The AI Controller Node should have been added to the scene tree, next to it is a scroll. Click on it to open the script that is attached to the AIController. The Godot game engine uses a scripting language called GDScript, which is syntactically similar to python. The script contains methods that need to be implemented in order to get our AI controller working."),zo=c(),_(We.$$.fragment),Bo=c(),it=a("p"),In=s("In order to implement these methods, we will need to create a class that inherits from AIController3D. This is easy to do in Godot, and is called \u201Cextending\u201D a class."),Ho=c(),X=a("p"),Pn=s("Right click the AIController3D Node and click \u201CExtend Script\u201D and call the new script "),Zt=a("code"),Tn=s("controller.gd"),Ln=s(". You should now have an almost empty script file that looks like this:"),Fo=c(),_(ze.$$.fragment),Yo=c(),ht=a("p"),Rn=s("We will now implement the 4 missing methods, delete this code and replace it with the following:"),Uo=c(),_(Be.$$.fragment),Jo=c(),pt=a("p"),Sn=s("We have now defined the agent\u2019s observation, which is the position and velocity of the ball in its local cooridinate space. We have also defined the action space of the agent, which is a single contuninous value ranging from -1 to +1."),Ko=c(),ee=a("p"),qn=s("The next step is to update the Player\u2019s script to use the actions from the AIController, edit the Player\u2019s script by clicking on the scroll next to the player node, update the code in "),Vt=a("code"),Cn=s("Player.gd"),Nn=s(" to the following the following:"),Qo=c(),_(He.$$.fragment),Zo=c(),ct=a("p"),Dn=s("We now need to synchronize between the game running in Godot and the neural network being trained in Python. Godot RL agents provides a node that does just that. Open the train.tscn scene, right click on the root node and click \u201CAdd child node\u201D. Then, search for \u201Csync\u201D and add a Godot RL Agents Sync node. This node handles the communication between Python and Godot over TCP."),Vo=c(),Fe=a("p"),Mn=s("You can run training live in the the editor, but first launching the python training with "),Xt=a("code"),On=s("python examples/clean_rl_example.py \u2014env-id=debug"),Xo=c(),dt=a("p"),Wn=s("In this simple example, a reasonable policy is learned in several minutes. You may wish to speed up training, click on the Sync node in the train scene and you will see there is a \u201CSpeed Up\u201D property exposed in the editor:"),ea=c(),Ye=a("img"),ta=c(),ft=a("p"),zn=s("Try setting this property up to 8 to speed up training. This can be a great benefit on more complex environments, like the multi-player FPS we will learn about in the next chapter."),oa=c(),N=a("h3"),te=a("a"),eo=a("span"),_(Ue.$$.fragment),Bn=c(),to=a("span"),Hn=s("There\u2019s more!"),aa=c(),oe=a("p"),Fn=s("We have only scratched the surface of what can be achieved with Godot RL Agents, the library includes custom sensors and cameras to enrich the information available to the agent. Take a look at the "),Je=a("a"),Yn=s("examples"),Un=s(" to find out more!"),la=c(),D=a("h2"),ae=a("a"),oo=a("span"),_(Ke.$$.fragment),Jn=c(),ao=a("span"),Kn=s("Author"),na=c(),Qe=a("p"),Qn=s("This section was written by "),ut=a("a"),Zn=s("Edward Beeching"),this.h()},l(e){const i=zr('[data-svelte="svelte-1phssyn"]',document.head);I=l(i,"META",{name:!0,content:!0}),i.forEach(t),no=d(e),P=l(e,"H1",{class:!0});var ra=n(P);O=l(ra,"A",{id:!0,class:!0,href:!0});var hs=n(O);wt=l(hs,"SPAN",{});var ps=n(wt);w(se.$$.fragment,ps),ps.forEach(t),hs.forEach(t),Ia=d(ra),yt=l(ra,"SPAN",{});var cs=n(yt);Pa=r(cs,"Godot RL Agents"),cs.forEach(t),ra.forEach(t),so=d(e),T=l(e,"P",{});var lo=n(T);re=l(lo,"A",{href:!0,rel:!0});var ds=n(re);Ta=r(ds,"Godot RL Agents"),ds.forEach(t),La=r(lo," is an Open Source package that allows video game creators, AI researchers and hobbyists the opportunity "),bt=l(lo,"STRONG",{});var fs=n(bt);Ra=r(fs,"to learn complex behaviors for their Non Player Characters or agents"),fs.forEach(t),Sa=r(lo,"."),lo.forEach(t),ro=d(e),Ve=l(e,"P",{});var us=n(Ve);qa=r(us,"The library provides:"),us.forEach(t),io=d(e),f=l(e,"UL",{});var v=n(f);ie=l(v,"LI",{});var ia=n(ie);Ca=r(ia,"An interface between games created in the\xA0"),he=l(ia,"A",{href:!0,rel:!0});var ms=n(he);Na=r(ms,"Godot Engine"),ms.forEach(t),Da=r(ia,"\xA0and Machine Learning algorithms running in Python"),ia.forEach(t),Ma=d(v),m=l(v,"LI",{});var M=n(m);Oa=r(M,"Wrappers for four well known rl frameworks: "),pe=l(M,"A",{href:!0,rel:!0});var gs=n(pe);Wa=r(gs,"StableBaselines3"),gs.forEach(t),za=r(M,", "),ce=l(M,"A",{href:!0,rel:!0});var vs=n(ce);Ba=r(vs,"CleanRL"),vs.forEach(t),Ha=r(M,", "),de=l(M,"A",{href:!0,rel:!0});var _s=n(de);Fa=r(_s,"Sample Factory"),_s.forEach(t),Ya=r(M," and\xA0"),fe=l(M,"A",{href:!0,rel:!0});var ws=n(fe);Ua=r(ws,"Ray RLLib"),ws.forEach(t),M.forEach(t),Ja=d(v),Et=l(v,"LI",{});var ys=n(Et);Ka=r(ys,"Support for memory-based agents with LSTM or attention based interfaces"),ys.forEach(t),Qa=d(v),Xe=l(v,"LI",{});var Vn=n(Xe);Za=r(Vn,"Support for "),At=l(Vn,"EM",{});var bs=n(At);Va=r(bs,"2D and 3D games"),bs.forEach(t),Vn.forEach(t),Xa=d(v),ue=l(v,"LI",{});var ha=n(ue);el=r(ha,"A suite of "),kt=l(ha,"EM",{});var Es=n(kt);tl=r(Es,"AI sensors"),Es.forEach(t),ol=r(ha," to augment your agent\u2019s capacity to observe the game world"),ha.forEach(t),al=d(v),me=l(v,"LI",{});var pa=n(me);ll=r(pa,"Godot and Godot RL Agents are "),Gt=l(pa,"STRONG",{});var As=n(Gt);nl=r(As,"completely free and open source under a very permissive MIT license"),As.forEach(t),sl=r(pa,". No strings attached, no royalties, nothing."),pa.forEach(t),v.forEach(t),ho=d(e),g=l(e,"P",{});var le=n(g);rl=r(le,"You can find out more about Godot RL agents on their "),ge=l(le,"A",{href:!0,rel:!0});var ks=n(ge);il=r(ks,"GitHub page"),ks.forEach(t),hl=r(le," or their AAAI-2022 Workshop\xA0"),ve=l(le,"A",{href:!0,rel:!0});var Gs=n(ve);pl=r(Gs,"paper"),Gs.forEach(t),cl=r(le,". The library\u2019s creator, "),_e=l(le,"A",{href:!0,rel:!0});var xs=n(_e);dl=r(xs,"Ed Beeching"),xs.forEach(t),fl=r(le,", is a Research Scientist here at Hugging Face."),le.forEach(t),po=d(e),L=l(e,"H2",{class:!0});var ca=n(L);W=l(ca,"A",{id:!0,class:!0,href:!0});var $s=n(W);xt=l($s,"SPAN",{});var js=n(xt);w(we.$$.fragment,js),js.forEach(t),$s.forEach(t),ul=d(ca),$t=l(ca,"SPAN",{});var Is=n($t);ml=r(Is,"Create a custom RL environment with Godot RL Agents"),Is.forEach(t),ca.forEach(t),co=d(e),z=l(e,"P",{});var da=n(z);gl=r(da,"In this section, you will "),jt=l(da,"STRONG",{});var Ps=n(jt);vl=r(Ps,"learn how to create a custom environment in the Godot Game Engine"),Ps.forEach(t),_l=r(da," and then implement an AI controller that learns to play with Deep Reinforcement Learning."),da.forEach(t),fo=d(e),B=l(e,"P",{});var fa=n(B);wl=r(fa,"The example game we create today is simple, "),It=l(fa,"STRONG",{});var Ts=n(It);yl=r(Ts,"but shows off many of the features of the Godot Engine and the Godot RL Agents library"),Ts.forEach(t),bl=r(fa,".You can then dive into the examples for more complex environments and behaviors."),fa.forEach(t),uo=d(e),H=l(e,"P",{});var ua=n(H);El=r(ua,"The environment we will be building today is called Ring Pong, the game of pong but the pitch is a ring and the paddle moves around the ring. The "),Pt=l(ua,"STRONG",{});var Ls=n(Pt);Al=r(Ls,"objective is to keep the ball bouncing inside the ring"),Ls.forEach(t),kl=r(ua,"."),ua.forEach(t),mo=d(e),ye=l(e,"IMG",{src:!0,alt:!0}),go=d(e),R=l(e,"H3",{class:!0});var ma=n(R);F=l(ma,"A",{id:!0,class:!0,href:!0});var Rs=n(F);Tt=l(Rs,"SPAN",{});var Ss=n(Tt);w(be.$$.fragment,Ss),Ss.forEach(t),Rs.forEach(t),Gl=d(ma),Lt=l(ma,"SPAN",{});var qs=n(Lt);xl=r(qs,"Installing the Godot Game Engine"),qs.forEach(t),ma.forEach(t),vo=d(e),k=l(e,"P",{});var mt=n(k);$l=r(mt,"The "),Ee=l(mt,"A",{href:!0,rel:!0});var Cs=n(Ee);jl=r(Cs,"Godot game engine"),Cs.forEach(t),Il=r(mt," is an open source tool for the "),Rt=l(mt,"STRONG",{});var Ns=n(Rt);Pl=r(Ns,"creation of video games, tools and user interfaces"),Ns.forEach(t),Tl=r(mt,"."),mt.forEach(t),_o=d(e),Y=l(e,"P",{});var ga=n(Y);Ll=r(ga,"Godot Engine is a feature-packed, cross-platform game engine designed to create 2D and 3D games from a unified interface. It provides a comprehensive set of common tools, so users "),St=l(ga,"STRONG",{});var Ds=n(St);Rl=r(Ds,"can focus on making games without having to reinvent the wheel"),Ds.forEach(t),Sl=r(ga,". Games can be exported in one click to a number of platforms, including the major desktop platforms (Linux, macOS, Windows) as well as mobile (Android, iOS) and web-based (HTML5) platforms."),ga.forEach(t),wo=d(e),u=l(e,"P",{});var j=n(u);ql=r(j,"While we will guide you through the steps to implement your agent, you may wish to learn more about the Godot Game Engine. Their "),Ae=l(j,"A",{href:!0,rel:!0});var Ms=n(Ae);Cl=r(Ms,"documentation"),Ms.forEach(t),Nl=r(j," is thorough, there are many tutorials on YouTube we would also recommend "),ke=l(j,"A",{href:!0,rel:!0});var Os=n(ke);Dl=r(Os,"GDQuest"),Os.forEach(t),Ml=r(j,", "),Ge=l(j,"A",{href:!0,rel:!0});var Ws=n(Ge);Ol=r(Ws,"KidsCanCode"),Ws.forEach(t),Wl=r(j," and "),xe=l(j,"A",{href:!0,rel:!0});var zs=n(xe);zl=r(zs,"Bramwell"),zs.forEach(t),Bl=r(j," as sources of information."),j.forEach(t),yo=d(e),U=l(e,"P",{});var va=n(U);Hl=r(va,"In order to create games in Godot, "),qt=l(va,"STRONG",{});var Bs=n(qt);Fl=r(Bs,"you must first download the editor"),Bs.forEach(t),Yl=r(va,". The latest version Godot RL agents was updated to use Godot 4 beta, as we are expecting this to be released in the next few months."),va.forEach(t),bo=d(e),et=l(e,"P",{});var Hs=n(et);Ul=r(Hs,"At the time of writing the latest beta version was beta 14 which can be downloaded at the following links:"),Hs.forEach(t),Eo=d(e),G=l(e,"UL",{});var gt=n(G);Ct=l(gt,"LI",{});var Fs=n(Ct);$e=l(Fs,"A",{href:!0,rel:!0});var Ys=n($e);Jl=r(Ys,"Windows"),Ys.forEach(t),Fs.forEach(t),Kl=d(gt),Nt=l(gt,"LI",{});var Us=n(Nt);je=l(Us,"A",{href:!0,rel:!0});var Js=n(je);Ql=r(Js,"Mac"),Js.forEach(t),Us.forEach(t),Zl=d(gt),Dt=l(gt,"LI",{});var Ks=n(Dt);Ie=l(Ks,"A",{href:!0,rel:!0});var Qs=n(Ie);Vl=r(Qs,"Linux"),Qs.forEach(t),Ks.forEach(t),gt.forEach(t),Ao=d(e),S=l(e,"H3",{class:!0});var _a=n(S);J=l(_a,"A",{id:!0,class:!0,href:!0});var Zs=n(J);Mt=l(Zs,"SPAN",{});var Vs=n(Mt);w(Pe.$$.fragment,Vs),Vs.forEach(t),Zs.forEach(t),Xl=d(_a),Ot=l(_a,"SPAN",{});var Xs=n(Ot);en=r(Xs,"Loading the starter project"),Xs.forEach(t),_a.forEach(t),ko=d(e),tt=l(e,"P",{});var er=n(tt);tn=r(er,"We provide two versions of the codebase:"),er.forEach(t),Go=d(e),K=l(e,"UL",{});var wa=n(K);Wt=l(wa,"LI",{});var tr=n(Wt);Te=l(tr,"A",{href:!0,rel:!0});var or=n(Te);on=r(or,"A starter project, to download and follow along for this tutorial"),or.forEach(t),tr.forEach(t),an=d(wa),zt=l(wa,"LI",{});var ar=n(zt);Le=l(ar,"A",{href:!0,rel:!0});var lr=n(Le);ln=r(lr,"A final version of the project, for comparison and debugging."),lr.forEach(t),ar.forEach(t),wa.forEach(t),xo=d(e),x=l(e,"P",{});var vt=n(x);nn=r(vt,"To load the project, in the Godot Project Manager click "),Bt=l(vt,"STRONG",{});var nr=n(Bt);sn=r(nr,"Import"),nr.forEach(t),rn=r(vt,", navigate to where the files are located and load the "),Ht=l(vt,"STRONG",{});var sr=n(Ht);hn=r(sr,"project.godot"),sr.forEach(t),pn=r(vt," file."),vt.forEach(t),$o=d(e),ot=l(e,"P",{});var rr=n(ot);cn=r(rr,"If you press F5 or play in the editor, you should be able to play the game in human mode. There are several instances of the game running, this is because we want to speed up training our AI agent with many parallel environments."),rr.forEach(t),jo=d(e),q=l(e,"H3",{class:!0});var ya=n(q);Q=l(ya,"A",{id:!0,class:!0,href:!0});var ir=n(Q);Ft=l(ir,"SPAN",{});var hr=n(Ft);w(Re.$$.fragment,hr),hr.forEach(t),ir.forEach(t),dn=d(ya),Yt=l(ya,"SPAN",{});var pr=n(Yt);fn=r(pr,"Installing the Godot RL Agents plugin"),pr.forEach(t),ya.forEach(t),Io=d(e),at=l(e,"P",{});var cr=n(at);un=r(cr,"The Godot RL Agents plugin can be installed from the Github repo or with the Godot Asset Lib in the editor."),cr.forEach(t),Po=d(e),lt=l(e,"P",{});var dr=n(lt);mn=r(dr,"First click on the AssetLib and search for \u201Crl\u201D"),dr.forEach(t),To=d(e),Se=l(e,"IMG",{src:!0,alt:!0}),Lo=d(e),Z=l(e,"P",{});var ba=n(Z);gn=r(ba,"Then click on Godot RL Agents, click Download and unselect the LICIENSE and "),qe=l(ba,"A",{href:!0,rel:!0});var fr=n(qe);vn=r(fr,"README.md"),fr.forEach(t),_n=r(ba," files. Then click install."),ba.forEach(t),Ro=d(e),Ce=l(e,"IMG",{src:!0,alt:!0}),So=d(e),nt=l(e,"P",{});var ur=n(nt);wn=r(ur,"The Godot RL Agents plugin is now downloaded to your machine your machine. Now click on Project \u2192 Project settings and enable the addon:"),ur.forEach(t),qo=d(e),Ne=l(e,"IMG",{src:!0,alt:!0}),Co=d(e),C=l(e,"H3",{class:!0});var Ea=n(C);V=l(Ea,"A",{id:!0,class:!0,href:!0});var mr=n(V);Ut=l(mr,"SPAN",{});var gr=n(Ut);w(De.$$.fragment,gr),gr.forEach(t),mr.forEach(t),yn=d(Ea),Jt=l(Ea,"SPAN",{});var vr=n(Jt);bn=r(vr,"Adding the AI controller"),vr.forEach(t),Ea.forEach(t),No=d(e),st=l(e,"P",{});var _r=n(st);En=r(_r,"We now want to add an AI controller to our game. Open the player.tscn scene, on the left you should see a hierarchy of nodes that looks like this:"),_r.forEach(t),Do=d(e),Me=l(e,"IMG",{src:!0,alt:!0}),Mo=d(e),$=l(e,"P",{});var _t=n($);An=r(_t,"Right click the "),Kt=l(_t,"STRONG",{});var wr=n(Kt);kn=r(wr,"Player"),wr.forEach(t),Gn=r(_t," node and click "),Qt=l(_t,"STRONG",{});var yr=n(Qt);xn=r(yr,"Add Child Node."),yr.forEach(t),$n=r(_t," There are many nodes listed here, search for AIController3D and create it."),_t.forEach(t),Oo=d(e),Oe=l(e,"IMG",{src:!0,alt:!0}),Wo=d(e),rt=l(e,"P",{});var br=n(rt);jn=r(br,"The AI Controller Node should have been added to the scene tree, next to it is a scroll. Click on it to open the script that is attached to the AIController. The Godot game engine uses a scripting language called GDScript, which is syntactically similar to python. The script contains methods that need to be implemented in order to get our AI controller working."),br.forEach(t),zo=d(e),w(We.$$.fragment,e),Bo=d(e),it=l(e,"P",{});var Er=n(it);In=r(Er,"In order to implement these methods, we will need to create a class that inherits from AIController3D. This is easy to do in Godot, and is called \u201Cextending\u201D a class."),Er.forEach(t),Ho=d(e),X=l(e,"P",{});var Aa=n(X);Pn=r(Aa,"Right click the AIController3D Node and click \u201CExtend Script\u201D and call the new script "),Zt=l(Aa,"CODE",{});var Ar=n(Zt);Tn=r(Ar,"controller.gd"),Ar.forEach(t),Ln=r(Aa,". You should now have an almost empty script file that looks like this:"),Aa.forEach(t),Fo=d(e),w(ze.$$.fragment,e),Yo=d(e),ht=l(e,"P",{});var kr=n(ht);Rn=r(kr,"We will now implement the 4 missing methods, delete this code and replace it with the following:"),kr.forEach(t),Uo=d(e),w(Be.$$.fragment,e),Jo=d(e),pt=l(e,"P",{});var Gr=n(pt);Sn=r(Gr,"We have now defined the agent\u2019s observation, which is the position and velocity of the ball in its local cooridinate space. We have also defined the action space of the agent, which is a single contuninous value ranging from -1 to +1."),Gr.forEach(t),Ko=d(e),ee=l(e,"P",{});var ka=n(ee);qn=r(ka,"The next step is to update the Player\u2019s script to use the actions from the AIController, edit the Player\u2019s script by clicking on the scroll next to the player node, update the code in "),Vt=l(ka,"CODE",{});var xr=n(Vt);Cn=r(xr,"Player.gd"),xr.forEach(t),Nn=r(ka," to the following the following:"),ka.forEach(t),Qo=d(e),w(He.$$.fragment,e),Zo=d(e),ct=l(e,"P",{});var $r=n(ct);Dn=r($r,"We now need to synchronize between the game running in Godot and the neural network being trained in Python. Godot RL agents provides a node that does just that. Open the train.tscn scene, right click on the root node and click \u201CAdd child node\u201D. Then, search for \u201Csync\u201D and add a Godot RL Agents Sync node. This node handles the communication between Python and Godot over TCP."),$r.forEach(t),Vo=d(e),Fe=l(e,"P",{});var Xn=n(Fe);Mn=r(Xn,"You can run training live in the the editor, but first launching the python training with "),Xt=l(Xn,"CODE",{});var jr=n(Xt);On=r(jr,"python examples/clean_rl_example.py \u2014env-id=debug"),jr.forEach(t),Xn.forEach(t),Xo=d(e),dt=l(e,"P",{});var Ir=n(dt);Wn=r(Ir,"In this simple example, a reasonable policy is learned in several minutes. You may wish to speed up training, click on the Sync node in the train scene and you will see there is a \u201CSpeed Up\u201D property exposed in the editor:"),Ir.forEach(t),ea=d(e),Ye=l(e,"IMG",{src:!0,alt:!0}),ta=d(e),ft=l(e,"P",{});var Pr=n(ft);zn=r(Pr,"Try setting this property up to 8 to speed up training. This can be a great benefit on more complex environments, like the multi-player FPS we will learn about in the next chapter."),Pr.forEach(t),oa=d(e),N=l(e,"H3",{class:!0});var Ga=n(N);te=l(Ga,"A",{id:!0,class:!0,href:!0});var Tr=n(te);eo=l(Tr,"SPAN",{});var Lr=n(eo);w(Ue.$$.fragment,Lr),Lr.forEach(t),Tr.forEach(t),Bn=d(Ga),to=l(Ga,"SPAN",{});var Rr=n(to);Hn=r(Rr,"There\u2019s more!"),Rr.forEach(t),Ga.forEach(t),aa=d(e),oe=l(e,"P",{});var xa=n(oe);Fn=r(xa,"We have only scratched the surface of what can be achieved with Godot RL Agents, the library includes custom sensors and cameras to enrich the information available to the agent. Take a look at the "),Je=l(xa,"A",{href:!0,rel:!0});var Sr=n(Je);Yn=r(Sr,"examples"),Sr.forEach(t),Un=r(xa," to find out more!"),xa.forEach(t),la=d(e),D=l(e,"H2",{class:!0});var $a=n(D);ae=l($a,"A",{id:!0,class:!0,href:!0});var qr=n(ae);oo=l(qr,"SPAN",{});var Cr=n(oo);w(Ke.$$.fragment,Cr),Cr.forEach(t),qr.forEach(t),Jn=d($a),ao=l($a,"SPAN",{});var Nr=n(ao);Kn=r(Nr,"Author"),Nr.forEach(t),$a.forEach(t),na=d(e),Qe=l(e,"P",{});var es=n(Qe);Qn=r(es,"This section was written by "),ut=l(es,"A",{href:!0});var Dr=n(ut);Zn=r(Dr,"Edward Beeching"),Dr.forEach(t),es.forEach(t),this.h()},h(){p(I,"name","hf:doc:metadata"),p(I,"content",JSON.stringify(Yr)),p(O,"id","godot-rl-agents"),p(O,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(O,"href","#godot-rl-agents"),p(P,"class","relative group"),p(re,"href","https://github.com/edbeeching/godot_rl_agents"),p(re,"rel","nofollow"),p(he,"href","https://godotengine.org/"),p(he,"rel","nofollow"),p(pe,"href","https://stable-baselines3.readthedocs.io/en/master/"),p(pe,"rel","nofollow"),p(ce,"href","https://docs.cleanrl.dev/"),p(ce,"rel","nofollow"),p(de,"href","https://www.samplefactory.dev/"),p(de,"rel","nofollow"),p(fe,"href","https://docs.ray.io/en/latest/rllib-algorithms.html"),p(fe,"rel","nofollow"),p(ge,"href","https://github.com/edbeeching/godot_rl_agents"),p(ge,"rel","nofollow"),p(ve,"href","https://arxiv.org/abs/2112.03636"),p(ve,"rel","nofollow"),p(_e,"href","https://edbeeching.github.io/"),p(_e,"rel","nofollow"),p(W,"id","create-a-custom-rl-environment-with-godot-rl-agents"),p(W,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(W,"href","#create-a-custom-rl-environment-with-godot-rl-agents"),p(L,"class","relative group"),Ze(ye.src,os="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/ringpong.gif")||p(ye,"src",os),p(ye,"alt","Ring Pong"),p(F,"id","installing-the-godot-game-engine"),p(F,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(F,"href","#installing-the-godot-game-engine"),p(R,"class","relative group"),p(Ee,"href","https://godotengine.org/"),p(Ee,"rel","nofollow"),p(Ae,"href","https://docs.godotengine.org/en/latest/index.html"),p(Ae,"rel","nofollow"),p(ke,"href","https://www.gdquest.com/"),p(ke,"rel","nofollow"),p(Ge,"href","https://kidscancode.org/godot_recipes/4.x/"),p(Ge,"rel","nofollow"),p(xe,"href","https://www.youtube.com/channel/UCczi7Aq_dTKrQPF5ZV5J3gg"),p(xe,"rel","nofollow"),p($e,"href","https://downloads.tuxfamily.org/godotengine/4.0/beta14/Godot_v4.0-beta14_win64.exe.zip"),p($e,"rel","nofollow"),p(je,"href","https://downloads.tuxfamily.org/godotengine/4.0/beta14/Godot_v4.0-beta14_macos.universal.zip"),p(je,"rel","nofollow"),p(Ie,"href","https://downloads.tuxfamily.org/godotengine/4.0/beta14/Godot_v4.0-beta14_linux.x86_64.zip"),p(Ie,"rel","nofollow"),p(J,"id","loading-the-starter-project"),p(J,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(J,"href","#loading-the-starter-project"),p(S,"class","relative group"),p(Te,"href","https://drive.google.com/file/d/1C7xd3TibJHlxFEJPBgBLpksgxrFZ3D8e/view?usp=share_link"),p(Te,"rel","nofollow"),p(Le,"href","https://drive.google.com/file/d/1k-b2Bu7uIA6poApbouX4c3sq98xqogpZ/view?usp=share_link"),p(Le,"rel","nofollow"),p(Q,"id","installing-the-godot-rl-agents-plugin"),p(Q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(Q,"href","#installing-the-godot-rl-agents-plugin"),p(q,"class","relative group"),Ze(Se.src,as="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/godot1.png")||p(Se,"src",as),p(Se,"alt","Godot"),p(qe,"href","http://README.md"),p(qe,"rel","nofollow"),Ze(Ce.src,ls="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/godot2.png")||p(Ce,"src",ls),p(Ce,"alt","Godot"),Ze(Ne.src,ns="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/godot3.png")||p(Ne,"src",ns),p(Ne,"alt","Godot"),p(V,"id","adding-the-ai-controller"),p(V,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(V,"href","#adding-the-ai-controller"),p(C,"class","relative group"),Ze(Me.src,ss="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/godot4.png")||p(Me,"src",ss),p(Me,"alt","Godot"),Ze(Oe.src,rs="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/godot5.png")||p(Oe,"src",rs),p(Oe,"alt","Godot"),Ze(Ye.src,is="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/godot6.png")||p(Ye,"src",is),p(Ye,"alt","Godot"),p(te,"id","theres-more"),p(te,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(te,"href","#theres-more"),p(N,"class","relative group"),p(Je,"href","https://github.com/edbeeching/godot_rl_agents_examples"),p(Je,"rel","nofollow"),p(ae,"id","author"),p(ae,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(ae,"href","#author"),p(D,"class","relative group"),p(ut,"href","https://twitter.com/edwardbeeching")},m(e,i){o(document.head,I),h(e,no,i),h(e,P,i),o(P,O),o(O,wt),y(se,wt,null),o(P,Ia),o(P,yt),o(yt,Pa),h(e,so,i),h(e,T,i),o(T,re),o(re,Ta),o(T,La),o(T,bt),o(bt,Ra),o(T,Sa),h(e,ro,i),h(e,Ve,i),o(Ve,qa),h(e,io,i),h(e,f,i),o(f,ie),o(ie,Ca),o(ie,he),o(he,Na),o(ie,Da),o(f,Ma),o(f,m),o(m,Oa),o(m,pe),o(pe,Wa),o(m,za),o(m,ce),o(ce,Ba),o(m,Ha),o(m,de),o(de,Fa),o(m,Ya),o(m,fe),o(fe,Ua),o(f,Ja),o(f,Et),o(Et,Ka),o(f,Qa),o(f,Xe),o(Xe,Za),o(Xe,At),o(At,Va),o(f,Xa),o(f,ue),o(ue,el),o(ue,kt),o(kt,tl),o(ue,ol),o(f,al),o(f,me),o(me,ll),o(me,Gt),o(Gt,nl),o(me,sl),h(e,ho,i),h(e,g,i),o(g,rl),o(g,ge),o(ge,il),o(g,hl),o(g,ve),o(ve,pl),o(g,cl),o(g,_e),o(_e,dl),o(g,fl),h(e,po,i),h(e,L,i),o(L,W),o(W,xt),y(we,xt,null),o(L,ul),o(L,$t),o($t,ml),h(e,co,i),h(e,z,i),o(z,gl),o(z,jt),o(jt,vl),o(z,_l),h(e,fo,i),h(e,B,i),o(B,wl),o(B,It),o(It,yl),o(B,bl),h(e,uo,i),h(e,H,i),o(H,El),o(H,Pt),o(Pt,Al),o(H,kl),h(e,mo,i),h(e,ye,i),h(e,go,i),h(e,R,i),o(R,F),o(F,Tt),y(be,Tt,null),o(R,Gl),o(R,Lt),o(Lt,xl),h(e,vo,i),h(e,k,i),o(k,$l),o(k,Ee),o(Ee,jl),o(k,Il),o(k,Rt),o(Rt,Pl),o(k,Tl),h(e,_o,i),h(e,Y,i),o(Y,Ll),o(Y,St),o(St,Rl),o(Y,Sl),h(e,wo,i),h(e,u,i),o(u,ql),o(u,Ae),o(Ae,Cl),o(u,Nl),o(u,ke),o(ke,Dl),o(u,Ml),o(u,Ge),o(Ge,Ol),o(u,Wl),o(u,xe),o(xe,zl),o(u,Bl),h(e,yo,i),h(e,U,i),o(U,Hl),o(U,qt),o(qt,Fl),o(U,Yl),h(e,bo,i),h(e,et,i),o(et,Ul),h(e,Eo,i),h(e,G,i),o(G,Ct),o(Ct,$e),o($e,Jl),o(G,Kl),o(G,Nt),o(Nt,je),o(je,Ql),o(G,Zl),o(G,Dt),o(Dt,Ie),o(Ie,Vl),h(e,Ao,i),h(e,S,i),o(S,J),o(J,Mt),y(Pe,Mt,null),o(S,Xl),o(S,Ot),o(Ot,en),h(e,ko,i),h(e,tt,i),o(tt,tn),h(e,Go,i),h(e,K,i),o(K,Wt),o(Wt,Te),o(Te,on),o(K,an),o(K,zt),o(zt,Le),o(Le,ln),h(e,xo,i),h(e,x,i),o(x,nn),o(x,Bt),o(Bt,sn),o(x,rn),o(x,Ht),o(Ht,hn),o(x,pn),h(e,$o,i),h(e,ot,i),o(ot,cn),h(e,jo,i),h(e,q,i),o(q,Q),o(Q,Ft),y(Re,Ft,null),o(q,dn),o(q,Yt),o(Yt,fn),h(e,Io,i),h(e,at,i),o(at,un),h(e,Po,i),h(e,lt,i),o(lt,mn),h(e,To,i),h(e,Se,i),h(e,Lo,i),h(e,Z,i),o(Z,gn),o(Z,qe),o(qe,vn),o(Z,_n),h(e,Ro,i),h(e,Ce,i),h(e,So,i),h(e,nt,i),o(nt,wn),h(e,qo,i),h(e,Ne,i),h(e,Co,i),h(e,C,i),o(C,V),o(V,Ut),y(De,Ut,null),o(C,yn),o(C,Jt),o(Jt,bn),h(e,No,i),h(e,st,i),o(st,En),h(e,Do,i),h(e,Me,i),h(e,Mo,i),h(e,$,i),o($,An),o($,Kt),o(Kt,kn),o($,Gn),o($,Qt),o(Qt,xn),o($,$n),h(e,Oo,i),h(e,Oe,i),h(e,Wo,i),h(e,rt,i),o(rt,jn),h(e,zo,i),y(We,e,i),h(e,Bo,i),h(e,it,i),o(it,In),h(e,Ho,i),h(e,X,i),o(X,Pn),o(X,Zt),o(Zt,Tn),o(X,Ln),h(e,Fo,i),y(ze,e,i),h(e,Yo,i),h(e,ht,i),o(ht,Rn),h(e,Uo,i),y(Be,e,i),h(e,Jo,i),h(e,pt,i),o(pt,Sn),h(e,Ko,i),h(e,ee,i),o(ee,qn),o(ee,Vt),o(Vt,Cn),o(ee,Nn),h(e,Qo,i),y(He,e,i),h(e,Zo,i),h(e,ct,i),o(ct,Dn),h(e,Vo,i),h(e,Fe,i),o(Fe,Mn),o(Fe,Xt),o(Xt,On),h(e,Xo,i),h(e,dt,i),o(dt,Wn),h(e,ea,i),h(e,Ye,i),h(e,ta,i),h(e,ft,i),o(ft,zn),h(e,oa,i),h(e,N,i),o(N,te),o(te,eo),y(Ue,eo,null),o(N,Bn),o(N,to),o(to,Hn),h(e,aa,i),h(e,oe,i),o(oe,Fn),o(oe,Je),o(Je,Yn),o(oe,Un),h(e,la,i),h(e,D,i),o(D,ae),o(ae,oo),y(Ke,oo,null),o(D,Jn),o(D,ao),o(ao,Kn),h(e,na,i),h(e,Qe,i),o(Qe,Qn),o(Qe,ut),o(ut,Zn),sa=!0},p:Br,i(e){sa||(b(se.$$.fragment,e),b(we.$$.fragment,e),b(be.$$.fragment,e),b(Pe.$$.fragment,e),b(Re.$$.fragment,e),b(De.$$.fragment,e),b(We.$$.fragment,e),b(ze.$$.fragment,e),b(Be.$$.fragment,e),b(He.$$.fragment,e),b(Ue.$$.fragment,e),b(Ke.$$.fragment,e),sa=!0)},o(e){E(se.$$.fragment,e),E(we.$$.fragment,e),E(be.$$.fragment,e),E(Pe.$$.fragment,e),E(Re.$$.fragment,e),E(De.$$.fragment,e),E(We.$$.fragment,e),E(ze.$$.fragment,e),E(Be.$$.fragment,e),E(He.$$.fragment,e),E(Ue.$$.fragment,e),E(Ke.$$.fragment,e),sa=!1},d(e){t(I),e&&t(no),e&&t(P),A(se),e&&t(so),e&&t(T),e&&t(ro),e&&t(Ve),e&&t(io),e&&t(f),e&&t(ho),e&&t(g),e&&t(po),e&&t(L),A(we),e&&t(co),e&&t(z),e&&t(fo),e&&t(B),e&&t(uo),e&&t(H),e&&t(mo),e&&t(ye),e&&t(go),e&&t(R),A(be),e&&t(vo),e&&t(k),e&&t(_o),e&&t(Y),e&&t(wo),e&&t(u),e&&t(yo),e&&t(U),e&&t(bo),e&&t(et),e&&t(Eo),e&&t(G),e&&t(Ao),e&&t(S),A(Pe),e&&t(ko),e&&t(tt),e&&t(Go),e&&t(K),e&&t(xo),e&&t(x),e&&t($o),e&&t(ot),e&&t(jo),e&&t(q),A(Re),e&&t(Io),e&&t(at),e&&t(Po),e&&t(lt),e&&t(To),e&&t(Se),e&&t(Lo),e&&t(Z),e&&t(Ro),e&&t(Ce),e&&t(So),e&&t(nt),e&&t(qo),e&&t(Ne),e&&t(Co),e&&t(C),A(De),e&&t(No),e&&t(st),e&&t(Do),e&&t(Me),e&&t(Mo),e&&t($),e&&t(Oo),e&&t(Oe),e&&t(Wo),e&&t(rt),e&&t(zo),A(We,e),e&&t(Bo),e&&t(it),e&&t(Ho),e&&t(X),e&&t(Fo),A(ze,e),e&&t(Yo),e&&t(ht),e&&t(Uo),A(Be,e),e&&t(Jo),e&&t(pt),e&&t(Ko),e&&t(ee),e&&t(Qo),A(He,e),e&&t(Zo),e&&t(ct),e&&t(Vo),e&&t(Fe),e&&t(Xo),e&&t(dt),e&&t(ea),e&&t(Ye),e&&t(ta),e&&t(ft),e&&t(oa),e&&t(N),A(Ue),e&&t(aa),e&&t(oe),e&&t(la),e&&t(D),A(Ke),e&&t(na),e&&t(Qe)}}}const Yr={local:"godot-rl-agents",sections:[{local:"create-a-custom-rl-environment-with-godot-rl-agents",sections:[{local:"installing-the-godot-game-engine",title:"Installing the Godot Game Engine"},{local:"loading-the-starter-project",title:"Loading the starter project"},{local:"installing-the-godot-rl-agents-plugin",title:"Installing the Godot RL Agents plugin"},{local:"adding-the-ai-controller",title:"Adding the AI controller"},{local:"theres-more",title:"There\u2019s more!"}],title:"Create a custom RL environment with Godot RL Agents"},{local:"author",title:"Author"}],title:"Godot RL Agents"};function Ur(ts){return Hr(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Zr extends Mr{constructor(I){super();Or(this,I,Ur,Fr,Wr,{})}}export{Zr as default,Yr as metadata};
